/**
 *	@file	?.cpp
 *	@brief
 *	@author	tenk*
 *	@date	200?-??
 */

#include <stdio.h>
#include <stdlib.h>
#include "../CharsetConv.h"


class App {
public:
	App() : srcEnc_(0), dstEnc_(0) {}
	~App() {}

	int main(int argc, const char* argv[]);

private:
	int  usage();
	int  option(const char* arg);
	bool one(const char* name);

private:
	const char* srcEnc_;
	const char* dstEnc_;
};



/** g.
 */
int App::usage()
{
	fprintf(stderr, "usage> test [-opts] file(s)\n"
		   "  R}hCc[̐`.\n"
		   "  -sNAME   ̓GR[h\n"
		   "  -dNAME   o̓GR[h\n"
		  );
	return 0;
}



/** C.
 */
int App::main(int argc, const char* argv[])
{
	int		i;

	if (argc < 2)
		return usage();

	// IvV擾.
	for (i = 1; i < argc; ++i) {
		if (argv[i][0] == '-') {
			if (option(argv[i]) == 0)
				return 1;
		}
	}

	if (srcEnc_ == 0) {
		fprintf(stderr, "̓GR[fBOw肳ĂȂ\n");
		return 1;
	} else if (dstEnc_ == 0) {
		fprintf(stderr, "o̓GR[fBOw肳ĂȂ\n");
		return 1;
	}

	// t@C擾.
	for (i = 1; i < argc; ++i) {
		const char* p = argv[i];
		if (*p != '-') {
			if (one(p) == 0)
				return 1;
		}
	}

	return 0;
}



/** IvV̏.
 */
int App::option(const char* arg)
{
	const char* p = arg + 1;
	switch (*p++) {
	case '?':
		usage();
		break;

	case 's':
		srcEnc_ = p;
		break;

	case 'd':
		dstEnc_ = p;
		break;

	default:
		fprintf(stderr, "bad option '%s'", arg);
		return 0;
	}
	return 1;
}



/** t@CP̏.
 */
bool App::one(const char* name)
{
	CharsetConv	cc(dstEnc_, srcEnc_);
	fprintf(stderr, "%s [%s]->[%s]\n", name, srcEnc_, dstEnc_);
	FILE* fp = fopen(name, "rt");
	if (fp == 0) {
		fprintf(stderr, "t@C %s Ȃ\n", name);
		return 0;
	}
	char src[0x1000];
  #if 0
	while (fgets(src, sizeof src, fp) != 0) {
		char dst[0x6000];
		size_t	srcSz = strlen(src);
		size_t	dstSz = sizeof dst;
		if (srcSz > sizeof src)
			srcSz = sizeof src;
		//cc.conv(src, srcSz, dst, dstSz);
		dstSz = cc.conv(dst, dstSz, src, srcSz);
		//printf("%s", dst);
		if (dstSz != size_t(-1))
			fwrite(dst, 1, dstSz, stdout);
	}
  #else
	while (fgets(src, sizeof src, fp) != 0) {
		char	 dst[0x6000];
		size_t	 dstSz = cc.strConv(dst, sizeof dst, src);
		if (dstSz != size_t(-1))
			printf("%s", dst);
	}
  #endif
	fclose(fp);
	return 1;
}



// ===========================================================================

int main(int argc, const char* argv[])
{
	App	app;
	// ExArgv(&argc, &argv);
	// UNITST_RUN_ALL();		// mainWinMain̏[ɌĂяȏz.
  #if defined _WIN32
	if (FAILED(::CoInitialize(NULL))) {
		printf("COMłȂ\n");
		return 0;
	}
  #endif
	return app.main(argc, argv);
}

